<template>
  <v-text-field
    v-bind="$attrs"
    :value="value"
    :label="$t('email', { required: requiredEmail ? '*' : '' })"
    prepend-inner-icon="mdi-email"
    v-on="$listeners"
    @input="onChange"
    @blur="onBlur"
  >
    <template v-slot:append>
      <v-progress-circular
        v-if="isLoading"
        size="20"
        width="2"
        indeterminate
      />
      <v-icon
        v-else
        v-text="appendEmailIcon"
      />
    </template>
  </v-text-field>
</template>

<script>
  const isEmailUnavailable = errorMessage => {
    return errorMessage === 'The email has already been taken.'
  }

  export default {
    name: 'EmailField',
    props: {
      value: String,
      requiredEmail: {
        type: Boolean,
        required: false,
        value: false,
      },
    },
    data () {
      return {
        isLoading: false,
        appendEmailIcon: '',
      }
    },
    methods: {
      emitEmailValue (value) {
        this.$emit('input', value)
      },
      emitIsEmailAddressAvailable (status) {
        this.$emit('emailAddressAvailable', status)
      },
      onChange (event) {
        this.emitEmailValue(event)
        this.emitIsEmailAddressAvailable(null)
      },
      onBlur () {
        this.isLoading = true
        this.$store.dispatch('auth/checksIfTheEmailHasAlreadyBeenTaken', this.value)
          .then(() => {
            this.emitIsEmailAddressAvailable(true)
            this.appendEmailIcon = 'mdi-check-circle'
          })
          .catch(error => {
            const errorMessage = error.response.data.errors.email[0]
            if (isEmailUnavailable(errorMessage)) {
              this.emitIsEmailAddressAvailable(false)
              this.appendEmailIcon = 'mdi-close-circle'
            }
          })
          .finally(() => {
            this.isLoading = false
          })
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          email: 'Email{required}',
        },
        'en-US': {
          email: 'Email{required}',
        },
      },
    },
  }
</script>
